exec("add-ons/System_Mail/ITEMs/Proj.cs");

exec("add-ons/System_Mail/ITEMs/Note/Note.cs");
exec("add-ons/System_Mail/ITEMs/Letter/Letter.cs");
exec("add-ons/System_Mail/ITEMs/Card/Card.cs");
exec("add-ons/System_Mail/ITEMs/Package/Package.cs");

exec("add-ons/System_Mail/SCRIPTs/Server/Package.cs");
exec("add-ons/System_Mail/SCRIPTs/Server/Events.cs");

exec("add-ons/System_Mail/BRICKs/DropBox/DropBox.cs");
exec("add-ons/System_Mail/BRICKs/Mailbox/Mailbox.cs");
exec("add-ons/System_Mail/BRICKs/POBox/POBox.cs");

//Add to mission cleanup?
if(!isObject(mlbx_mailboxBrs))
	new SimSet("mlbx_mailboxBrs");
if(!isObject("mlbx_BlackWhiteLists"))
	new ScriptGroup("mlbx_BlackWhiteLists");

//RTB preferences
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)
		exec("Add-Ons/System_ReturnToBlockland/Hooks/serverControl.cs");

	RTB_registerPref("Mail Cooldown Timer",		"Mail System",	"$Pref::Server::System_Mail::MailCooldown",		"int 0 300",	"System_Mail",	5,		false,	false,	false);
	RTB_registerPref("Inbox Limit",				"Mail System",	"$Pref::Server::System_Mail::InboxLimit",		"int 0 200",	"System_Mail",	50,		false,	false,	false);
	RTB_registerPref("Enable Events",			"Mail System",	"$Pref::Server::System_Mail::EnabEvents",		"bool",			"System_Mail",	true,	false,	false,	false);
}
else
{
	if($Pref::Server::System_Mail::MailCooldown $= "")
		$Pref::Server::System_Mail::MailCooldown = 5;		//time - in seconds - for players to wait before being able to send another mail item (hard limit of 300s)
	if($Pref::Server::System_Mail::InboxLimit $= "")
		$Pref::Server::System_Mail::InboxLimit = 50;		//max amount of inbox items each player can receive (hard limit of 200)
	if($Pref::Server::System_Mail::EnabEvents $= "")
		$Pref::Server::System_Mail::EnabEvents = true;		//toggle mail system events (for now toggles the output event "mlbx_setMailBr")
}


////////////////////////////////////////////////////////////////////////////////////////////////////


function SERVERCMDmlbx_setMailSrvr(%cl,%type,%arrNum,%mailData)
{
	//%arrNum is used for sending letter text and package item tool inv position
	
	%pl = %cl.player;
	%brID = %pl.mlbxBrID;
	%brPlyrID = SERVERCMDmlbx_Request(%cl,"getBrID",%brID);
	%inboxLimit = mClamp($Pref::Server::System_Mail::InboxLimit,0,200);
	%coolDown = mClamp($Pref::Server::System_Mail::MailCooldown,0,300);
	
	if(!%fail && %fail = (%cl.mlbx_ver !$= "2"))																	//Check client version
		commandtoClient(%cl,'messageboxOK',"Mailbox | Invalid Version","This server is running version \"2\" of the mail system add-on. Please download the latest version on the <a:forum.blockland.us/index.php?topic=310042.0>Blockland Forums</a>.");
	if(!%fail && %fail = !%pl.tool[%pl.mlbxCurrTool].isMlbxItem)														//Make sure item is a mail item
		commandtoClient(%cl,'messageboxOK',"Mailbox | Invalid Item","The current item doesn't support the mail system.");
	if(%fail = !isObject(%brID) || %brID.getClassName() !$= "fxDTSBrick" || !%brID.isMlbx)				//Make sure brick (which mail is being sent to) is a valid mailbox brick
		commandtoClient(%cl,'messageboxOK',"Mailbox | Invalid Brick","This brick is not a mailbox.");
	if(!%fail && %fail = ((%mailArrNum = %brID.mailArrNum = mClamp(%brID.mailArrNum,0,%inboxLimit)) == %inboxLimit))	//Make sure mailbox is not full
		commandtoClient(%cl,'messageboxOK',"Mailbox | Mail Full","Player's mailbox is full; no new messages can be received.");
	if(!%fail && %fail = !isObject(%pl))																				//Player object must exist
		commandtoClient(%cl,'messageboxOK',"Mailbox | No Player","No physical player detected.");
	if(!%fail)																											//Check if mail disabled and black / whitelist
		%fail = !SERVERCMDmlbx_Request(%cl,"checkBlocking",%brPlyrID);
	if(!%fail && %fail = ((getSimTime() - %cl.mlbx_lastMsg) / 1000) < %coolDown)
		commandtoClient(%cl,'messageboxOK',"Mailbox | Spam","Please wait " @ %coolDown @ " seconds before sending another mail item.");
	//if(%type !$= "ltr" && (strReplace(%mailData," ","") $= "" || %mailData $= "<font:impact:24>text..."))
		//commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Invalid mail data.");
	if(%fail)
		return;
	
	
	//////////////////////////////////////////////////

	
	//Mail type
	switch$(%type)
	{
		case "note":
			%brID.mail[%mailArrNum] = %mailData;
			%brID.mailInfo[%mailArrNum] = true TAB "Note" TAB %cl.bl_id @ " - " @ getSubStr(%cl.name,0,20) TAB getDateTime();
			commandtoClient(%cl,'messageboxOK',"Mailbox | Success!","Note sent successfully.");
			
		
		case "ltr":
			%arrNum = mClamp(%arrNum,0,6);
			%brID.mail[%mailArrNum,%arrNum] = %mailData;
			
			//Set mail info, msg client and close plyr GUI when finished uploading letter text
			if(%arrNum == 6)
			{
				%brID.mailInfo[%mailArrNum] = true TAB "Letter" TAB %cl.bl_id @ " - " @ getSubStr(%cl.name,0,20) TAB getDateTime();
				commandtoClient(%cl,'messageboxOK',"Mailbox | Success!","Letter sent successfully.");
			}
			else
				return;
		
		
		case "card":
			%mailData = mClamp(%mailData,0,54);
			%brID.mail[%mailArrNum] = %mailData;
			%brID.mailInfo[%mailArrNum] = true TAB "Card" TAB %cl.bl_id @ " - " @ getSubStr(%cl.name,0,20) TAB getDateTime();
			commandtoClient(%cl,'messageboxOK',"Mailbox | Success!","Card sent successfully.");
		
		
		case "pckg":
			if(!isObject(%mailData) || %mailData.getClassName() !$= "itemData" || %mailData == MlbxPackageItem.getID() || %pl.tool[%pl.mlbxCurrTool].getName() !$= "MlbxPackageItem")
			{
				commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Selected item can't be added to package.");
				return;
			}
			%brID.mail[%mailArrNum] = %mailData;
			%brID.mailInfo[%mailArrNum] = true TAB "Package" TAB %cl.bl_id @ " - " @ getSubStr(%cl.name,0,20) TAB getDateTime();
			commandtoClient(%cl,'messageboxOK',"Mailbox | Success!","Package sent successfully.");
			
			//Remove packaged item from player inv
			messageClient(%cl,'MsgItemPickup','',%arrNum,"");
			%pl.tool[%arrNum] = "";
		
		
		default:
			return;
	}
	
	
	//////////////////////////////////////////////////
	

	%brID.mailArrNum++;
	%brID.mailUpdated = true;
	%cl.mlbx_lastMsg = getSimTime();
	
	//Remove item from player tools inventory
	messageClient(%cl,'MsgItemPickup','',%pl.mlbxCurrTool,"");
	%pl.unMountImage(0);
	%pl.tool[%pl.mlbxCurrTool] = "";
	%pl.mlbxBrID = "";
	%pl.mlbxCurrTool = "";
	%pl.mlbxDpBxRtrnFunc = "";
	
	//update brick datablock (to show mailbox open)
	if(isObject(%brAuxDB = %brID.getDatablock().mlbx_auxDB))
		%brID.setDatablock(%brAuxDB);
	
	//Close player GUI
	commandToClient(%cl,'mlbx_GUIUpdate',"closeAll");
}


////////////////////////////////////////////////////////////////////////////////////////////////////


function SERVERCMDmlbx_Request(%cl,%action,%data)
{
	if(%action !$= "verSetup") //don't run checks when storing client version
	{
		%pl = %cl.player;
		
		if(%fail = (%cl.mlbx_ver !$= "2"))																			//Check client version
			commandtoClient(%cl,'messageboxOK',"Mailbox | Invalid Version","This server is running version \"2\" of the mail system add-on. Please download the latest version on the <a:forum.blockland.us/index.php?topic=310042.0>Blockland Forums</a>.");
		if(!%fail && %fail = !isObject(%pl))																			//Player object must exist
			commandtoClient(%cl,'messageboxOK',"Mailbox | No Player","No physical player detected.");
		if(%fail)
			return;
	}
	
	
	//////////////////////////////////////////////////
	
	
	switch$(%action)
	{
		case "createNoteGUI" or "createLtrGUI" or "createCardGUI" or "createPckgGUI":
			if(!isObject(%brID = %data) || %brID.getClassName() !$= "fxDTSBrick" || !%brID.isMlbx) //if is mailbox br
				return;
			if(!SERVERCMDmlbx_Request(%cl,"checkBlocking",SERVERCMDmlbx_Request(%cl,"getBrID",%brID))) //Check if mail disabled and black / whitelist
				return;
			%pl.mlbxCurrTool = %pl.currTool;
			%pl.mlbxBrID = %brID; //store brick ID for use later
			
			if(%pl.mlbxCurrTool > -1)
			{
				commandToClient(%cl,'mlbx_GUIUpdate',%action,"","");
				
				if(%action $= "createPckgGUI")
				{
					%mxTls = mClamp(%pl.getDatablock().maxTools,0,20);
					
					for(%n = 0; %n < %mxTls; %n++)
					{
						if((%itemID = %pl.tool[%n]) > 0 && %pl.tool[%pl.currTool] != %itemID)
							commandToClient(%cl,'mlbx_GUIUpdate',"addPckgItem",%n,%itemID);
					}
				}
			}
		
		
		case "createNoteGUIDpBx" or "createLtrGUIDpBx" or "createCardGUIDpBx" or "createPckgGUIDpBx": //request drop box GUI (before setting up creation GUI)
			%pl.mlbxDpBxRtrnFunc = strReplace(%action,"DpBx",""); //%pl.mlbxCurrTool //%pl.mlbxBrID (current %brID is for drop box, which will cause issues)
			commandToClient(%cl,'mlbx_GUIUpdate',"resetDpBxList","","");
			%count = mlbx_mailboxBrs.getCount();
			
			for(%n = 0; %n < %count; %n++)
			{
				%tmpBr = mlbx_mailboxBrs.getObject(%n);
				%name = getSubStr(%tmpBr.getName(),1,51);
				
				if(%name !$= "")
				{
					commandToClient(%cl,'mlbx_GUIUpdate',"addToDpBxList","",%name);
					%nBrCount++;
				}
			}
			if(%count == 0 || %nBrCount == 0)
				commandtoClient(%cl,'messageboxOK',"Mailbox | No Named Bricks","No named mail bricks were found.");
			else
				commandToClient(%cl,'mlbx_GUIUpdate',"openDpBx","","");
		
		
		case "DpBxCheck": //check br name from drop box (open mail creation GUI if br found)
			%count = mlbx_mailboxBrs.getCount();
			
			for(%n = 0; %n < %count; %n++)
			{
				%tmpBr = mlbx_mailboxBrs.getObject(%n);
				
				if(getSubStr(%tmpBr.getName(),1,51) $= %data)
				{
					SERVERCMDmlbx_Request(%cl,%pl.mlbxDpBxRtrnFunc,%tmpBr); //open / prep relative creation GUI
					return;
				}
			}
			
			commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Mail brick (based on name given) can't be found.");
			
			
		//////////////////////////////////////////////////
		
		
		case "verSetup": //store client add-on version
			%cl.mlbx_ver = %data;
		
		
		case "getBrID": //get id for player who planted brick (more reliable than %br.stackBL_ID)
			%group = getBrickGroupFromObject(%data).getName();
			%id = strReplace(%group,"BrickGroup_",""); //%group.bl_id?
			
			return %id;
		
		
		case "openMail":
			if(%fail = !isObject(%brID = %data) || %brID.getClassName() !$= "fxDTSBrick" || !%brID.isMlbx)
				commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Invalid mail brick.");
			if(!%fail && %fail = (%cl.bl_id != SERVERCMDmlbx_Request(%cl,"getBrID",%brID)))
				commandtoClient(%cl,'messageboxOK',"Mailbox | Access Denied","Only the player who planted this brick can access it's inbox.");
			if(%fail)
				return;
			
			if(%brID.mailUpdated)
			{
				%brID.mailUpdated = false;
				
				//Return brick to default datablock
				if(isObject(%brDefDB = %brID.getDatablock().mlbx_defDB))
					%brID.setDatablock(%brDefDB);
			}
			commandToClient(%cl,'mlbx_GUIUpdate',"clearMail","","");
			%mailArrNum = mClamp(%brID.mailArrNum,0,mClamp($Pref::Server::System_Mail::InboxLimit,0,200));
			%pl.mlbxBrID = %brID; //store brick ID for use later
			
			for(%n = 0; %n < %mailArrNum; %n++)
			{
				%dataB = %brID.mailInfo[%n];
				commandToClient(%cl,'mlbx_GUIUpdate',"addMail",%n,%dataB);
			}
			commandToClient(%cl,'mlbx_GUIUpdate',"openMail","","");
			
			//Send blocking options data to client GUI (when inbox is accessed)
			SERVERCMDmlbx_Request(%cl,"createBlockList","");
			%blkWhtList = "mlbx_BlkWhtList_" @ %cl.bl_id;
			commandToClient(%cl,'mlbx_GUIUpdate',"blockData","",%blkWhtList.mailDisabled TAB %blkWhtList.isWhiteList);
			
			
		case "deleteMail" or "deleteAllMail":
			if(%fail = !isObject(%brID = %pl.mlbxBrID) || %brID.getClassName() !$= "fxDTSBrick" || !%brID.isMlbx)
				commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Invalid mail brick.");
			if(!%fail && %fail = (%cl.bl_id != SERVERCMDmlbx_Request(%cl,"getBrID",%brID)))
				commandtoClient(%cl,'messageboxOK',"Mailbox | Access Denied","Only the player who planted this brick can delete mail from it's inbox.");
			if(!%fail && %fail = %action $= "deleteMail" && %data >= mClamp(%brID.mailArrNum,0,50))
				commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Array position has exceeded total amount of inbox items.");
			if(%fail)
				return;
			%mailRmvd = false;
			%mailArrNum = mClamp(%brID.mailArrNum,0,mClamp($Pref::Server::System_Mail::InboxLimit,0,200));
		
			//Update brick mail array(s)
			for(%n = 0; %n < %mailArrNum; %n++)
			{
				if(%n == %data || %action $= "deleteAllMail")
				{
					%brID.mail[%n] = "";
					%mailRmvd = true;
					
					if(getWord(%brID.mailInfo[%n],1) $= "Letter")
					{
						for(%nB = 0; %nB < 7; %nB++)
							%brID.mailInfo[%n,%nB] = "";
					}
					else
						%brID.mailInfo[%n] = "";
				}
				else if(%mailRmvd)
				{
					%brID.mail[%n - 1] = %brID.mail[%n];
					%brID.mailInfo[%n - 1] = %brID.mailInfo[%n];
					%brID.mail[%n] = "";
					%brID.mailInfo[%n] = "";
				}
			}
			
			//Update brick array count & client GUI
			if(%mailRmvd)
			{
				if(%action $= "deleteMail")
				{
					%brID.mailArrNum = mClamp(%brID.mailArrNum--,0,mClamp($Pref::Server::System_Mail::InboxLimit,0,200));
					commandToClient(%cl,'mlbx_GUIUpdate',"rmvMailRow",%data,"");
				}
				else
				{
					%brID.mailArrNum = "";
					commandToClient(%cl,'mlbx_GUIUpdate',"clearMail","","");
				}
			}
		
		
		case "viewMail":
			if(%fail = !isObject(%brID = %pl.mlbxBrID) || %brID.getClassName() !$= "fxDTSBrick" || !%brID.isMlbx)
				commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Invalid mail brick.");
			if(!%fail && %fail = (%cl.bl_id != SERVERCMDmlbx_Request(%cl,"getBrID",%brID)))
				commandtoClient(%cl,'messageboxOK',"Mailbox | Access Denied","Only the player who planted this brick can read mail from it's inbox.");
			if(%fail)
				return;
			
			%mailArrNum = mClamp(%data,0,mClamp($Pref::Server::System_Mail::InboxLimit,0,200) - 1);
			%mailType = getWord(%brID.mailInfo[%mailArrNum],1);
			%brID.mailInfo[%mailArrNum] = setWord(%brID.mailInfo[%mailArrNum],0,false); //set as read
			
			if(%mailType !$= "Letter")
				commandToClient(%cl,'mlbx_GUIUpdate',"view" @ %mailType,%mailArrNum,%brID.mail[%mailArrNum]);
			else
			{
				commandToClient(%cl,'mlbx_GUIUpdate',"viewLetterInit",%mailArrNum,"");
				
				for(%n = 0; %n < 7; %n++)
					commandToClient(%cl,'mlbx_GUIUpdate',"viewLetterRcv","",%brID.mail[%mailArrNum,%n]);
			}
		
		
		case "takePckgItem":
			%brID = %pl.mlbxBrID;
			%itemID = %brID.mail[%data];
			%mxTls = mClamp(%pl.getDatablock().maxTools,0,20);
			%slotFound = false;
			
			if(%fail = !isObject(%brID) || %brID.getClassName() !$= "fxDTSBrick" || !%brID.isMlbx)
				commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Invalid mail brick.");
			if(!%fail && %fail = (%cl.bl_id != SERVERCMDmlbx_Request(%cl,"getBrID",%brID)))
				commandtoClient(%cl,'messageboxOK',"Mailbox | Access Denied","Only the player who planted this brick can take packaged items from it's inbox.");
			if(!%fail && %fail = !isObject(%itemID) || %itemID.getClassName() !$= "itemData")
				commandtoClient(%cl,'messageboxOK',"Mailbox | Error","No item found.");
			if(!%fail && %fail = getWord(%brID.mailInfo[%data],1) !$= "Package")
				commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Mail type is not a package.");
			if(%fail)
				return;
			
			for(%n = 0; %n < %mxTls && !%slotFound; %n++)
			{
				if(%pl.tool[%n] == 0)
				{
					%slotFound = true;
					%emptySlot = %n;
				}
			}
			if(%slotFound)
			{
				messageClient(%cl,'MsgItemPickup','',%emptySlot,%itemID); //%pl.unMountImage(0);
				%pl.tool[%emptySlot] = %itemID;
				%brID.mail[%data] = "";
				commandToClient(%cl,'mlbx_GUIUpdate',"viewPckgRmv",%emptySlot,"");
				commandtoClient(%cl,'messageboxOK',"Mailbox | Success!","Item has been added to your player inventory.");
			}
			else
				commandtoClient(%cl,'messageboxOK',"Mailbox | Can't Add Item","No empty slot found for item in player inventory.");
			
			
		//////////////////////////////////////////////////
		
		
		case "clearFields":
			%pl.mlbxBrID = "";
			%pl.mlbxCurrTool = "";
			%pl.mlbxDpBxRtrnFunc = "";
			
		
		case "toggleIncMail":
			SERVERCMDmlbx_Request(%cl,"createBlockList","");
			%blkWhtList = "mlbx_BlkWhtList_" @ %cl.bl_id;
			%blkWhtList.mailDisabled = %data;
		
		
		case "toggleBlkWhtList":
			SERVERCMDmlbx_Request(%cl,"createBlockList","");
			%blkWhtList = "mlbx_BlkWhtList_" @ %cl.bl_id;
			%blkWhtList.isWhiteList = %data;
		
		
		case "clearSrvrBlockList":
			SERVERCMDmlbx_Request(%cl,"createBlockList",""); //???
			%blkWhtList = "mlbx_BlkWhtList_" @ %cl.bl_id;
			%listCount = mClamp(%blkWhtList.listCount,0,50);
			
			for(%n = 0; %n < %listCount; %n++)
				%blkWhtList.listData[%n] = "";
			%blkWhtList.listCount = "";
		
		
		case "addSrvrBlockList":
			SERVERCMDmlbx_Request(%cl,"createBlockList","");
			%blkWhtList = "mlbx_BlkWhtList_" @ %cl.bl_id;
			%row = mClamp(getField(%data,0),0,49);
			%idAdd = mFloor(getSubStr(getField(%data,1),0,9)); //mAbs
			%nameAdd = getField(%data,2);
			%blkWhtList.listData[%row] = %idAdd TAB %nameAdd;
			%blkWhtList.listCount = mClamp(%blkWhtList.listCount++,0,50);
		
		
		case "fnlSrvrBlockList":
			commandtoClient(%cl,'messageboxOK',"Mailbox | Success!","Changes applied successfully.");
		
		
		case "sendBlockList":
			SERVERCMDmlbx_Request(%cl,"createBlockList","");
			%blkWhtList = "mlbx_BlkWhtList_" @ %cl.bl_id;
			%listCount = mClamp(%blkWhtList.listCount,0,50);
			
			for(%n = 0; %n < %listCount; %n++)
				commandToClient(%cl,'mlbx_GUIUpdate',"blockListAdd",%n,%blkWhtList.listData[%n]);
		
		
		case "createBlockList":
			if(!isObject(%listN = "mlbx_BlkWhtList_" @ %cl.bl_id))
			{
				%list = new ScriptObject(%listN) //.listData[#] = "ID TAB Name";
				{
					mailDisabled = false;
					isWhiteList = false;
					listCount = 0;
				};
				mlbx_BlackWhiteLists.add(%list);
			}
		
		
		//////////////////////////////////////////////////
		
		
		case "checkBlocking":
			if((%bl_id_list = %data) == -1) //no longer needed?
				%bl_id_list = 999999;
			%bl_id_acc = %cl.bl_id;
			%blkWhtList = "mlbx_BlkWhtList_" @ %bl_id_list;
			%listCount = mClamp(%blkWhtList.listCount,0,50);
			
			//Check if mail disabled for player
			if(%blkWhtList.mailDisabled)
			{
				commandtoClient(%cl,'messageboxOK',"Mailbox | Mail Disabled","This player has disabled all incoming mail.");
				return false;
			}
			
			//Check mailbox owner's black / whitelist
			if(isObject(%blkWhtList))
			{
				//Blacklist
				if(!%blkWhtList.isWhiteList)
				{
					for(%n = 0; %n < %listCount; %n++)
					{
						if(%bl_id_acc == getField(%blkWhtList.listData[%n],0))
						{
							commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Unable to send mail to inbox.");
							return false;
						}
					}
				}
				
				//Whitelist
				else
				{
					for(%n = 0; %n < %listCount; %n++)
					{
						if(%bl_id_acc == getField(%blkWhtList.listData[%n],0))
							return true;
					}
					commandtoClient(%cl,'messageboxOK',"Mailbox | Error","Unable to send mail to inbox.");
					return false;
				}
			}
			return true;
	}
}